/*************************
* IGESt@Cǂݍ *
**************************/

#include "IGES_Parser.h"

// *body --- ̂\GeBeB̏WIuWFNgւ̃|C^
// TypeNum[] --- eGeBeB̐i[
int IGES_PARSER::IGES_Parser_Main(BODY *body,char IGES_fname[])
{
	FILE *fp;
	GlobalParam gpara;				// O[õp[^i[
	DirectoryParam *dpara;			// fBNg̃p[^i[
	char mes[256];					// bZ[W_vpstring
	int  line[SECTION_NUM];			// eZNṼCi[
	int  flag = 0;
	int  i;

	// IGESt@CI[v
	if((fp = fopen(IGES_fname,"r")) == NULL){
		sprintf(mes,"KOD_ERROR: Cannot open %s",IGES_fname);
		SetMessage(mes);
		return(KOD_ERR);
	}
	sprintf(mes,"Open %s",IGES_fname);
	SetMessage(mes);

	// eZNV̍s炩ߎ擾
	GetSectionLine(fp,line);

	// DirectoryParam̃[m
	line[SECTION_DIRECTORY] /= 2;		// fBNǵA2s1̃V[PX\̂2Ŋ̂fBNg̃CƂ
	dpara = (DirectoryParam *)malloc(sizeof(DirectoryParam)*line[SECTION_DIRECTORY]);
	if(dpara == NULL){
		SetMessage("KOD_ERROR: fail to allocate DirectoryParam");
		return(KOD_ERR);
	}

	// IGESt@Cǂݍ(eZNVɏ)
	for(i=0;i<SECTION_NUM;i++){
		if(i == SECTION_START){					// X^[gǂݍ
			flag = GetStartSection(fp,line[i]);
		}
		else if(i == SECTION_GLOBAL){			// O[oǂݍ
			flag = GetGlobalSection(fp,&gpara,line[i]);
		}
		else if(i == SECTION_DIRECTORY){		// fBNgǂݍ
			flag = GetDirectorySection(fp,dpara,body->TypeNum,line[i]);
		}
		else if(i == SECTION_PARAMETER){		// p[^ǂݍ
			body->NewBodyElem();				// BODY\̓̊eGeBeB̃[m
			flag = GetParameterSection(fp,dpara,*body,line[SECTION_DIRECTORY]);
		}
		else if(i == SECTION_TERMINATE){		// ^[~l[gǂݍ
			flag = GetTerminateSection(fp);
		}
		if(flag == KOD_ERR){
			body->DelBodyElem(TypeCount);		// ܂Ŋmۂ̃[
			return(KOD_ERR);
		}
	}
	ChangeEntityforNurbs(dpara,*body,line[SECTION_DIRECTORY]);	// \SNURBSɕύX
	flag = SearchMaxCoord(body,body->TypeNum);		// ̂̍őWlT(\ł̕\{肷邽)

	fclose(fp);

	free(dpara);

	return flag;
}

// ǂݍIGESt@COpenGLpɍœK
int IGES_PARSER::Optimize4OpenGL(BODY *body)
{
	ExpandKnotRange(body);		// mbgxNg͈̔͂OpenGL̎dlɉčœK
	CheckCWforTrim(body);		// gȐvAvOpenGL̎dlɉĕύX
	CheckDegenracy(body);		// k(2DpgbNȐ̎n_ƏI_vĂ邩)̃`FbN
	ModifyParamConect(body);	// pgbNʓ̃gȐm̂Ȃ`FbNAC

	return KOD_TRUE;
}

// kރ`FbN
int IGES_PARSER::CheckDegenracy(BODY *body)
{
	int flag;
	NURBS_Func NFunc;

	// kޗpNurbsȐ𕡍Ȑ̐
	if(body->TypeNum[_COMPOSITE_CURVE]){
		double T[4] = {0,0,NORM_KNOT_VAL,NORM_KNOT_VAL};
		double W[2] = {1,1};
		double V[2] = {0,NORM_KNOT_VAL};
		int prop[4] = {0,0,1,0};
		Coord cp[2];
		InitCoord(&cp[0]);
		InitCoord(&cp[1]);

		for(int i=0;i<body->TypeNum[_COMPOSITE_CURVE];i++){
			 NFunc.GenNurbsC(&body->CompC[i].DegeNurbs,2,2,4,T,W,cp,V,prop,1);	// kޗpNurbsȐ𕡍Ȑ̃GeBeB

			// eȐNURBSȐ݂̂ō\Ă肩2DpgbNvfł邩̃`FbN
			flag = 0;
			for(int j=0;j<body->CompC[i].N;j++){
				if(body->CompC[i].DEType[j] == NURBS_CURVE && body->CompC[i].pDE[j]->NurbsC.EntUseFlag == PARAMETRICELEM){
					flag++;				
				}
			}

			// NURBSȐō\Ă镡Ȑɑ΂āAn_ƏI_̍Wlr
			if(flag == body->CompC[i].N){
				Coord s,e;
				s = NFunc.CalcNurbsCCoord(&body->CompC[i].pDE[0]->NurbsC,body->CompC[i].pDE[0]->NurbsC.V[0]);					// n_
				e = NFunc.CalcNurbsCCoord(&body->CompC[i].pDE[body->CompC[i].N-1]->NurbsC,body->CompC[i].pDE[body->CompC[i].N-1]->NurbsC.V[1]);	// I_
				if(DiffCoord(s,e,1.0E-5) == KOD_FALSE){				// n_I_
					body->CompC[i].DegeNurbs.cp[0] = e;
					body->CompC[i].DegeNurbs.cp[1] = s;
					body->CompC[i].DegeFlag = KOD_FALSE;			// kނ̃tO𗧂Ă
				}
				else{
					body->CompC[i].DegeFlag = KOD_TRUE;				// kނȂ̃tO𗧂Ă
				}
			}
			else{
				body->CompC[i].DegeFlag = KOD_TRUE;					// ȐNurbsȐō\ĂȂꍇkނȂ̃tO
			}
		}
	}

	return KOD_TRUE;
}

// pgbNʓ̃gȐm̂Ȃ`FbNAC
int IGES_PARSER::ModifyParamConect(BODY *body)
{
	NURBSC *bc,*nc;

	// gȖ
	for(int i=0;i<body->TypeNum[_TRIMMED_SURFACE];i++){
		// Og
		for(int j=1;j<body->TrmS[i].pTO->pB->CompC.N;j++){
			bc = (NURBSC *)body->TrmS[i].pTO->pB->CompC.pDE[j-1];
			nc = (NURBSC *)body->TrmS[i].pTO->pB->CompC.pDE[j];
			if(DiffCoord2D(bc->cp[bc->K-1],nc->cp[0]) == KOD_FALSE)
				nc->cp[0] = SetCoord(bc->cp[bc->K-1]);
		}
		// g
		for(int j=0;j<body->TrmS[i].n2;j++){
			for(int k=1;k<body->TrmS[i].pTI[j]->pB->CompC.N;k++){
				bc = (NURBSC *)body->TrmS[i].pTI[j]->pB->CompC.pDE[k-1];
				nc = (NURBSC *)body->TrmS[i].pTI[j]->pB->CompC.pDE[k];
				if(DiffCoord2D(bc->cp[bc->K-1],nc->cp[0]) == KOD_FALSE)
					nc->cp[0] = SetCoord(bc->cp[bc->K-1]);
			}
		}
	}

	return KOD_TRUE;
}

// mbgxNg̐KSub1
int IGES_PARSER::ChangeKnotVecRange(double Range[],double Knot[],int N,int M,int K,double val)
{
	double _t[KNOTNUMMAX];
	for(int i=0;i<N;i++){
		_t[i] = ChangeKnot(Knot[i],Knot[M-1],Knot[K],val);
	}
	for(int i=0;i<N;i++){
		Knot[i] = _t[i];
	}
	Range[0] = 0;
	Range[1] = val;

	return KOD_TRUE;
}

// mbgxNg̐KSub2
double IGES_PARSER::ChangeKnot(double Knot,double M_,double K_,double val)
{
	return val*(Knot - M_)/(K_-M_);
}


// mbg̐K
// 0.0001ȉ炢̔ωOpenGLFȂ߁AmbgԊuLA0.0001ȏ̊Ԋu
// ɂȂ悤ɂB_ł͑SẴmbgԊuꗥ0`NORM_KNOT_VALĂAʂłB
// mbgԊu0.0001ȉ̏ꍇ̂݃mbgԊuL悤ɂׂB(2011/10)
// ׂ荇mbgxNg̍MIN_KNOT_RANGEȏɂȂ悤͈͂ύX
int IGES_PARSER::NormalizeKnotRange(BODY *body,double val)
{
	// g
	for(int i=0;i<body->TypeNum[_TRIMMED_SURFACE];i++){
		int M0 = body->TrmS[i].pts->M[0];
		int M1 = body->TrmS[i].pts->M[1];
		int K0 = body->TrmS[i].pts->K[0];
		int K1 = body->TrmS[i].pts->K[1];
		// gʂ̃pgbNʂɂOgȐ̕ύX
		for(int j=0;j<body->TrmS[i].pTO->pB->CompC.N;j++){
			NURBSC *nc = (NURBSC *)body->TrmS[i].pTO->pB->CompC.pDE[j];
			for(int k=0;k<nc->K;k++){	// pgbNʏNURBSȐ̃Rg[|Cgmbg̕ύXɍ킹ĕύX
				nc->cp[k].x = ChangeKnot(nc->cp[k].x,body->TrmS[i].pts->S[M0-1],body->TrmS[i].pts->S[K0],val);
				nc->cp[k].y = ChangeKnot(nc->cp[k].y,body->TrmS[i].pts->T[M1-1],body->TrmS[i].pts->T[K1],val);
			}
			ChangeKnotVecRange(nc->V,nc->T,nc->N,nc->M,nc->K,val);
		}
		// gʂ̃pgbNʂɂgȐ̕ύX
		for(int j=0;j<body->TrmS[i].n2;j++){
			for(int k=0;k<body->TrmS[i].pTI[j]->pB->CompC.N;k++){
				NURBSC *nc = (NURBSC *)body->TrmS[i].pTI[j]->pB->CompC.pDE[k];
				for(int l=0;l<nc->K;l++){
					nc->cp[l].x = ChangeKnot(nc->cp[l].x,body->TrmS[i].pts->S[M0-1],body->TrmS[i].pts->S[K0],val);
					nc->cp[l].y = ChangeKnot(nc->cp[l].y,body->TrmS[i].pts->T[M1-1],body->TrmS[i].pts->T[K1],val);
				}
				ChangeKnotVecRange(nc->V,nc->T,nc->N,nc->M,nc->K,val);
			}
		}
		// mbgxNg͈̔͂ύX
		ChangeKnotVecRange(body->TrmS[i].pts->U,body->TrmS[i].pts->S,body->TrmS[i].pts->N[0],M0,K0,val);
		ChangeKnotVecRange(body->TrmS[i].pts->V,body->TrmS[i].pts->T,body->TrmS[i].pts->N[1],M1,K1,val);
	}

	// NURBSȐ
	for(int i=0;i<body->TypeNum[_NURBSC];i++){
		if(body->NurbsC[i].EntUseFlag == 5) continue;	// ԏ̋Ȑ̂ݕύX
		ChangeKnotVecRange(body->NurbsC[i].V,body->NurbsC[i].T,body->NurbsC[i].N,body->NurbsC[i].M,body->NurbsC[i].K,val);
	}

	return KOD_TRUE;
}

// mbgxNg񂩂ׂ荇mbgxNg̍ŏlTԂ
double IGES_PARSER::SearchMinVecRange(double Knot[],int M,int K)
{
	double min = 1.0E+6;
	for(int i=M;i<=K;i++){
		double d = Knot[i]-Knot[i-1];
		if(!CheckZero(d,MID_ACCURACY) && d < min){
			min = d;
		}
	}

	return min;
}

// ׂ荇mbgxNg̍MIN_KNOT_RANGEȏɂȂ悤͈͂ύX
int IGES_PARSER::ExpandKnotRange(BODY *body)
{
	NormalizeKnotRange(body,NORM_KNOT_VAL);		// mbg0-1ɐK
	
	double min;

	// g
	for(int i=0;i<body->TypeNum[_TRIMMED_SURFACE];i++){
		int M0 = body->TrmS[i].pts->M[0];
		int M1 = body->TrmS[i].pts->M[1];
		int K0 = body->TrmS[i].pts->K[0];
		int K1 = body->TrmS[i].pts->K[1];

		double uval = NORM_KNOT_VAL;
		double vval = NORM_KNOT_VAL;
		min = SearchMinVecRange(body->TrmS[i].pts->S,M0,K0);	// umbgxNg̍ŏW𒲂ׂ
		if(min < MIN_KNOT_RANGE) {
			uval = MIN_KNOT_RANGE/min;			// ŏWMIN_KNOT_RANGEɂȂ{𓾂
		}

		min = SearchMinVecRange(body->TrmS[i].pts->T,M1,K1);	// vmbgxNg̍ŏW𒲂ׂ
		if(min < MIN_KNOT_RANGE){
			vval = MIN_KNOT_RANGE/min;			// ŏWMIN_KNOT_RANGEɂȂ{𓾂
		}

		// gʂ̃pgbNʂɂOgȐ̕ύX
		for(int j=0;j<body->TrmS[i].pTO->pB->CompC.N;j++){
			NURBSC *nc = (NURBSC *)body->TrmS[i].pTO->pB->CompC.pDE[j];
			for(int k=0;k<nc->K;k++){	// pgbNʏNURBSȐ̃Rg[|Cgmbg̕ύXɍ킹ĕύX
				nc->cp[k].x = ChangeKnot(nc->cp[k].x,body->TrmS[i].pts->S[M0-1],body->TrmS[i].pts->S[K0],uval);
				nc->cp[k].y = ChangeKnot(nc->cp[k].y,body->TrmS[i].pts->T[M1-1],body->TrmS[i].pts->T[K1],vval);
			}
			ChangeKnotVecRange(nc->V,nc->T,nc->N,nc->M,nc->K,NORM_KNOT_VAL);
		}
		// gʂ̃pgbNʂɂgȐ̕ύX
		for(int j=0;j<body->TrmS[i].n2;j++){
			for(int k=0;k<body->TrmS[i].pTI[j]->pB->CompC.N;k++){
				NURBSC *nc = (NURBSC *)body->TrmS[i].pTI[j]->pB->CompC.pDE[k];
				for(int l=0;l<nc->K;l++){
					nc->cp[l].x = ChangeKnot(nc->cp[l].x,body->TrmS[i].pts->S[M0-1],body->TrmS[i].pts->S[K0],uval);
					nc->cp[l].y = ChangeKnot(nc->cp[l].y,body->TrmS[i].pts->T[M1-1],body->TrmS[i].pts->T[K1],vval);
				}
				ChangeKnotVecRange(nc->V,nc->T,nc->N,nc->M,nc->K,NORM_KNOT_VAL);
			}
		}
		// mbgxNg͈̔͂ύX
		ChangeKnotVecRange(body->TrmS[i].pts->U,body->TrmS[i].pts->S,body->TrmS[i].pts->N[0],M0,K0,uval);
		ChangeKnotVecRange(body->TrmS[i].pts->V,body->TrmS[i].pts->T,body->TrmS[i].pts->N[1],M1,K1,vval);
	}

	// NURBSȐ
	for(int i=0;i<body->TypeNum[_NURBSC];i++){
		if(body->NurbsC[i].EntUseFlag == 5) continue;	// ԏ̋Ȑ̂ݕύX
		ChangeKnotVecRange(body->NurbsC[i].V,body->NurbsC[i].T,body->NurbsC[i].N,body->NurbsC[i].M,body->NurbsC[i].K,NORM_KNOT_VAL);
	}

	return KOD_TRUE;
}

// gɎgĂ镡ȐȂ鑽p`v肩v肩𒲂ׁAOg͔vAg͎v
// ɂȂ悤ɕύX
int IGES_PARSER::CheckCWforTrim(BODY *body)
{
	Coord *p;
	int flag;

	// g
	for(int i=0;i<body->TypeNum[_TRIMMED_SURFACE];i++){

		// gʂ̃pgbNʂɂOgȐ̕ύX
		p = NewCoord1(body->TrmS[i].pTO->pB->CompC.N);

		// Og\eNURBSȐ̎n_o
		for(int j=0;j<body->TrmS[i].pTO->pB->CompC.N;j++){
			NURBSC *nc = (NURBSC *)body->TrmS[i].pTO->pB->CompC.pDE[j];
			p[j] = SetCoord(nc->cp[0]);		
		}
		flag = DiscriminateCW2D(p,body->TrmS[i].pTO->pB->CompC.N);	// vEv𒲂ׂ

		// Ogv肾AvɕύX
		if(flag == KOD_FALSE){
			for(int j=0;j<body->TrmS[i].pTO->pB->CompC.N;j++){
				NURBSC *nc = (NURBSC *)body->TrmS[i].pTO->pB->CompC.pDE[j];
				Reverse(nc->cp,nc->K);		// Rg[|Cg̔]
				// mbgxNg𔽓]
				for(int k=0;k<nc->N;k++){
					nc->T[k] *= -1;
					nc->T[k] += nc->V[0]+nc->V[1];
				}
				Reverse(nc->T,nc->N);
			}
			// COMPELEM𔽓]
			ReverseCOMPELEM(&body->TrmS[i].pTO->pB->CompC);
		}

		FreeCoord1(p);
		// Og܂

		// gʂ̃pgbNʂɂgȐ̕ύX
		for(int j=0;j<body->TrmS[i].n2;j++){
			p = NewCoord1(body->TrmS[i].pTI[j]->pB->CompC.N);

			// g\eNURBSȐ̎n_o
			for(int k=0;k<body->TrmS[i].pTI[j]->pB->CompC.N;k++){
				NURBSC *nc = (NURBSC *)body->TrmS[i].pTI[j]->pB->CompC.pDE[k];
				p[k] = SetCoord(nc->cp[0]);
			}
			flag = DiscriminateCW2D(p,body->TrmS[i].pTI[j]->pB->CompC.N);	// vEv𒲂ׂ

			// gv肾AvɕύX
			if(flag == KOD_TRUE){
				for(int k=0;k<body->TrmS[i].pTI[j]->pB->CompC.N;k++){
					NURBSC *nc = (NURBSC *)body->TrmS[i].pTI[j]->pB->CompC.pDE[k];
					Reverse(nc->cp,nc->K);		// Rg[|Cg̔]
					// mbgxNg𔽓]
					for(int l=0;l<nc->N;l++){
						nc->T[l] *= -1;
						nc->T[l] += nc->V[0]+nc->V[1];
					}
					Reverse(nc->T,nc->N);
				}
				// COMPELEM𔽓]
				ReverseCOMPELEM(&body->TrmS[i].pTI[j]->pB->CompC);
			}

			FreeCoord1(p);
		}
	}

	return KOD_TRUE;
}

// COMPELEMz𔽓]
void IGES_PARSER::ReverseCOMPELEM(COMPC *CompC)
{
	int i,j;
	COMPELEM *tmp;

	for(i=0,j=CompC->N-1;i<j;i++,j--){
		tmp = CompC->pDE[i];
		CompC->pDE[i] = CompC->pDE[j];
		CompC->pDE[j] = tmp;
	}
}

// NURBSȐȊÕGeBeBNURBSȐɕϊAϊs񂪂΍Wϊ{
int IGES_PARSER::ChangeEntityforNurbs(DirectoryParam *dpara,BODY body,int dline)
{
	bool flag;

	for(int i=0;i<dline;i++){
		flag = KOD_FALSE;
		// ~/~->NURBSȐ
		if(dpara[i].entity_type == CIRCLE_ARC){
			body.NurbsC[TypeCount[_NURBSC]].EntUseFlag = body.CirA[dpara[i].entity_count].EntUseFlag;	// fBNg̏"Entity Use Flag"𓾂(NURBSC)
			if(GetNurbsCFromCirA(TypeCount[_NURBSC],dpara[i].entity_count,body) == KOD_ERR) return KOD_ERR;		// ~/~ʃp[^NURBSȐp[^𓾂
			flag = KOD_TRUE;
		}
		// ->NURBSȐ
		else if(dpara[i].entity_type == LINE){
			body.NurbsC[TypeCount[_NURBSC]].EntUseFlag = body.Line[dpara[i].entity_count].EntUseFlag;	// fBNg̏"Entity Use Flag"𓾂(NURBSC)
			if(GetNurbsCFromLine(TypeCount[_NURBSC],dpara[i].entity_count,body) == KOD_ERR) return KOD_ERR;		// p[^NURBSȐp[^𓾂
			flag = KOD_TRUE;
		}
		// ~/~ʁAȊŐȐGeBeB݂ꍇ́AVKɏǉĂ

		if(flag == KOD_TRUE){													// NURBSϊꂽGeBeBɑ΂
			if(dpara[i].p_tm){												// ϊs񂪑݂ꍇ
				for(int j=0;j<TypeCount[_TRANSFORMATION_MATRIX];j++){		// SĂ̕ϊs^Cv𒲂ׂ
					if(body.TMat[j].pD == dpara[i].p_tm){					// ΏۂƂȂϊs^Cvւ̃|C^
						if(TransformNurbsC(TypeCount[_NURBSC],j,body) == KOD_ERR) return KOD_ERR;	// NURBSȐWϊ
					}
				}
			}
			TypeCount[_NURBSC]++;											// NURBSC̐CNg
		}
	}

	return KOD_TRUE;
}

// p[^ǂݍ
int IGES_PARSER::GetParameterSection(FILE *fp,DirectoryParam *dpara,BODY body,int dline)
{
	int i,j;
	char str[COLUMN_MAX*5000];	// obt@(5000sm)
	char *p;					// 擪ʗp|C^
	int  pD;					// fBNgւ̋t|C^̒l

	// TypeCount̏
	for(i=0;i<ALL_ENTITY_TYPE_NUM;i++)
		TypeCount[i] = 0;

	// SGeBeB̃p[^ꂼ̃GeBeB\̂Ɋi[Ă
	for(i=0;i<dline;i++){
		// fBNg14tB[h̏ɁAstrɊep[^̃Cq킹
		strcpy(str,"");
		for(j=0;j<dpara[i].param_line_count;j++){
			fgets(buf,COLUMN_MAX_,fp);
			if((p = strchr(buf,';')) == NULL){
				p = strchr(buf,' ');
			}
			else{
				buf[p-buf] = '\0';		// R[hf~^óAR[hf~^I[ɂ
			}
			strncat(str,buf,p-buf+1);	// ep[^̃Cq킹Ă
		}
		p = &buf[COL_P_DIRECTORY];		// fBNgւ̋t|C^̒l炩ߒׂĂi֋Xj
		sscanf(p,"%d",&pD);

		// str𕪉eGeBeB\̂ɏ𖄂߂Ă
		// ̃GeBeBǉꍇ͈ȉɃR[hǉ

		// ~E~(NURBSȐƂẴGeBeBɓ)
		if(dpara[i].entity_type == CIRCLE_ARC){							
			if(GetCirAPara(str,pD,dpara,body) == KOD_ERR)  return KOD_ERR;					// ~/~ʃp[^̎擾
			body.CirA[TypeCount[_CIRCLE_ARC]].EntUseFlag = dpara[i].useflag_stat;	// fBNg̏"Entity Use Flag"𓾂
			dpara[i].entity_count = TypeCount[_CIRCLE_ARC];							// dparabody֘At
			TypeCount[_CIRCLE_ARC]++;					// ~E~ʃ^Cv̐CNg
		}
		// Ȑ
		else if(dpara[i].entity_type == COMPOSITE_CURVE){					
			if(GetCompCPara(str,pD,dpara,dline,body) == KOD_ERR)  return KOD_ERR;
			dpara[i].entity_count = TypeCount[_COMPOSITE_CURVE];					// dparabody֘At
			TypeCount[_COMPOSITE_CURVE]++;				// Ȑ^Cv̐CNg
		}
		// ~Ȑ
		else if(dpara[i].entity_type == CONIC_ARC){											
			if(GetConAPara(str,pD,dpara,body) == KOD_ERR)  return KOD_ERR;
			TypeCount[_CONIC_ARC]++;					// ~Ȑ^Cv̐CNg
		}
		// (NURBSȐƂẴGeBeBɓ)
		else if(dpara[i].entity_type == LINE){									
			if(GetLinePara(str,pD,dpara,body) == KOD_ERR)  return KOD_ERR;				// p[^̎擾
			body.Line[TypeCount[_LINE]].EntUseFlag = dpara[i].useflag_stat;		// fBNg̏"Entity Use Flag"𓾂(LINE)
			dpara[i].entity_count = TypeCount[_LINE];							// dparabody֘At
			TypeCount[_LINE]++;							// ^Cv̐CNg
		}
		// ϊs
		else if(dpara[i].entity_type == TRANSFORMATION_MATRIX){			
			if(GetTMatPara(str,pD,dpara,body) == KOD_ERR)  return KOD_ERR;
			dpara[i].entity_count = TypeCount[_TRANSFORMATION_MATRIX];			// dparabody֘At
			TypeCount[_TRANSFORMATION_MATRIX]++;		// ϊs^Cv̐CNg
		}
		// NURBSȐ
		else if(dpara[i].entity_type == NURBS_CURVE){		
			if(GetNurbsCPara(str,pD,dpara,body) == KOD_ERR)  return KOD_ERR;
			body.NurbsC[TypeCount[_NURBSC]].EntUseFlag = dpara[i].useflag_stat;	// fBNg̏"Entity Use Flag"𓾂
			dpara[i].entity_count = TypeCount[_NURBSC];							// dparabody֘At
			TypeCount[_NURBSC]++;		// NURBSȐ^Cv̐CNg
		}
		// NURBSȖ
		else if(dpara[i].entity_type == NURBS_SURFACE){		
			if(GetNurbsSPara(str,pD,dpara,body) == KOD_ERR)  return KOD_ERR;
			dpara[i].entity_count = TypeCount[_NURBSS];							// dparabody֘At
			TypeCount[_NURBSS]++;		// NURBSȖʃ^Cv̐CNg
		}
		// ʏ
		else if(dpara[i].entity_type == CURVE_ON_PARAMETRIC_SURFACE){	
			if(GeConpSPara(str,pD,dpara,dline,body) == KOD_ERR)  return KOD_ERR;
			dpara[i].entity_count = TypeCount[_CURVE_ON_PARAMETRIC_SURFACE];	// dparabody֘At
			TypeCount[_CURVE_ON_PARAMETRIC_SURFACE]++;	// ʏ^Cv̐CNg
		}
		// g	
		else if(dpara[i].entity_type == TRIMMED_SURFACE){				
			if(GetTrmSPara(str,pD,dpara,body) == KOD_ERR)  return KOD_ERR;
			dpara[i].entity_count = TypeCount[_TRIMMED_SURFACE];				// dparabody֘At
			TypeCount[_TRIMMED_SURFACE]++;				// gʃ^Cv̐CNg
		}
		// T|[gĂȂEntity Typȅꍇ
		else{
		//	char mes[256];
			//sprintf(mes,"Entity Type #%d:Unsupported",dpara[i].entity_type);
		//	SetMessage(mes);
			continue;
		}
	}

	return KOD_TRUE;
}

// Type100 ~E~ʂ̓ǂݍ
int IGES_PARSER::GetCirAPara(char str[],int pD,DirectoryParam *dpara,BODY body)
{
//	int i;
	char *p;
	double x[3],y[3];

	p = str;

	body.CirA[TypeCount[_CIRCLE_ARC]].zt = CatchStringD(&p);		// Z̐[
	x[0] = CatchStringD(&p);							// SWX
	body.CirA[TypeCount[_CIRCLE_ARC]].cp[0].x = x[0];
	y[0] = CatchStringD(&p);							// SWY
	body.CirA[TypeCount[_CIRCLE_ARC]].cp[0].y = y[0];
	x[1] = CatchStringD(&p);							// n_X
	body.CirA[TypeCount[_CIRCLE_ARC]].cp[1].x = x[1];
	y[1] = CatchStringD(&p);							// n_Y
	body.CirA[TypeCount[_CIRCLE_ARC]].cp[1].y = y[1];
	x[2] = CatchStringD(&p);							// I_X
	body.CirA[TypeCount[_CIRCLE_ARC]].cp[2].x = x[2];
	y[2] = CatchStringD(&p);							// I_Y
	body.CirA[TypeCount[_CIRCLE_ARC]].cp[2].y = y[2];

	body.CirA[TypeCount[_CIRCLE_ARC]].R = sqrt((x[1]-x[0])*(x[1]-x[0])+(y[1]-y[0])*(y[1]-y[0]));	// aZo

	body.CirA[TypeCount[_CIRCLE_ARC]].pD = pD;		// fBNgւ̋t|C^̒l

	InitDisplayStat(&body.CirA[TypeCount[_CIRCLE_ARC]].Dstat);	// \̏

	return KOD_TRUE;
}

// Type104 ~Ȑ̓ǂݍ
int IGES_PARSER::GetConAPara(char str[],int pD,DirectoryParam *dpara,BODY body)
{
	SetMessage("Type104:Unmounted");
	return KOD_TRUE;
}

// Type110 ̓ǂݍ
int IGES_PARSER::GetLinePara(char str[],int pD,DirectoryParam *dpara,BODY body)
{
	char *p;

	p = str;

	body.Line[TypeCount[_LINE]].cp[0].x = CatchStringD(&p);		// n_XW
	body.Line[TypeCount[_LINE]].cp[0].y = CatchStringD(&p);		// n_YW
	body.Line[TypeCount[_LINE]].cp[0].z = CatchStringD(&p);		// n_ZW
	body.Line[TypeCount[_LINE]].cp[1].x = CatchStringD(&p);		// I_XW
	body.Line[TypeCount[_LINE]].cp[1].y = CatchStringD(&p);		// I_YW
	body.Line[TypeCount[_LINE]].cp[1].z = CatchStringD(&p);		// I_ZW

	body.Line[TypeCount[_LINE]].pD = pD;		// fBNgւ̋t|C^̒l

	InitDisplayStat(&body.Line[TypeCount[_LINE]].Dstat);	// \̏

	return KOD_TRUE;
}

// Type124 ϊs̓ǂݍ
int IGES_PARSER::GetTMatPara(char str[],int pD,DirectoryParam *dpara,BODY body)
{
	int i,j;
	char *p;
	
	p = str;
	for(i=0;i<3;i++){
		for(j=0;j<4;j++){
			if(j != 3){
				body.TMat[TypeCount[_TRANSFORMATION_MATRIX]].R[i][j] = CatchStringD(&p);	// 3~3]s񐬕
			}
			else{
				body.TMat[TypeCount[_TRANSFORMATION_MATRIX]].T[i] = CatchStringD(&p);		// ixNg
			}
		}
	}
	
	body.TMat[TypeCount[_TRANSFORMATION_MATRIX]].pD = pD;		// DEւ̋t|C^̒l
	
	return KOD_TRUE;
}

// Type126 NRBSȐ̓ǂݍ
int IGES_PARSER::GetNurbsCPara(char str[],int pD,DirectoryParam *dpara,BODY body)
{
	char *p;
	int i=0;

	p = str;
	body.NurbsC[TypeCount[_NURBSC]].K = CatchStringI(&p) + 1;		// aL̏㑤YiRg[|Cg-1j̒l
	body.NurbsC[TypeCount[_NURBSC]].M = CatchStringI(&p) + 1;		// ֐̊K
	body.NurbsC[TypeCount[_NURBSC]].N = body.NurbsC[TypeCount[_NURBSC]].K + body.NurbsC[TypeCount[_NURBSC]].M;	// mbgxNg̐
	for(i=0;i<4;i++){	// u[A^vpeB4
		body.NurbsC[TypeCount[_NURBSC]].prop[i] = CatchStringI(&p);
	}

	// [m
	if(NFunc.New_NurbsC(&body.NurbsC[TypeCount[_NURBSC]],body.NurbsC[TypeCount[_NURBSC]].K,body.NurbsC[TypeCount[_NURBSC]].N) == KOD_ERR){
		SetMessage("PARAMETER SECTION KOD_ERROR:fail to allocate memory");
		return KOD_ERR;
	}

	for(i=0;i<body.NurbsC[TypeCount[_NURBSC]].N;i++){
		body.NurbsC[TypeCount[_NURBSC]].T[i] = CatchStringD(&p);	// mbgxNg̒l
	}
	for(i=0;i<body.NurbsC[TypeCount[_NURBSC]].K;i++){				// Weight̒l
		body.NurbsC[TypeCount[_NURBSC]].W[i] = CatchStringD(&p);
	}
	for(i=0;i<body.NurbsC[TypeCount[_NURBSC]].K;i++){				// Rg[|Cg̍Wl
		body.NurbsC[TypeCount[_NURBSC]].cp[i].x = CatchStringD(&p);
		body.NurbsC[TypeCount[_NURBSC]].cp[i].y = CatchStringD(&p);
		body.NurbsC[TypeCount[_NURBSC]].cp[i].z = CatchStringD(&p);
	}
	body.NurbsC[TypeCount[_NURBSC]].V[0] = CatchStringD(&p);		// p[^͈̔
	body.NurbsC[TypeCount[_NURBSC]].V[1] = CatchStringD(&p);

	// @xNg͋LqĂꍇƂĂȂꍇ悤Ȃ̂ŁALqĂꍇ̂ݓǂݍ
	if(strchr(p,',') != NULL){
		body.NurbsC[TypeCount[_NURBSC]].norm.x = CatchStringD(&p);	// @xNg
		body.NurbsC[TypeCount[_NURBSC]].norm.y = CatchStringD(&p);
		body.NurbsC[TypeCount[_NURBSC]].norm.z = CatchStringD(&p);
	}

	body.NurbsC[TypeCount[_NURBSC]].pD = pD;		// DEւ̋t|C^̒l

	InitDisplayStat(&body.NurbsC[TypeCount[_NURBSC]].Dstat);	// \̏

	return KOD_TRUE;
}

// Type128 NURBSȖʂ̓ǂݍ
int IGES_PARSER::GetNurbsSPara(char str[],int pD,DirectoryParam *dpara,BODY body)
{
	char *p;
	int i=0,j=0;

	p = str;

	body.NurbsS[TypeCount[_NURBSS]].K[0] = CatchStringI(&p) + 1;	// uRg[|Cg̐
	body.NurbsS[TypeCount[_NURBSS]].K[1] = CatchStringI(&p) + 1;	// vRg[|Cg̐
	body.NurbsS[TypeCount[_NURBSS]].M[0] = CatchStringI(&p) + 1;	// ֐uK
	body.NurbsS[TypeCount[_NURBSS]].M[1] = CatchStringI(&p) + 1;	// ֐vK
	body.NurbsS[TypeCount[_NURBSS]].N[0] = body.NurbsS[TypeCount[_NURBSS]].K[0] + body.NurbsS[TypeCount[_NURBSS]].M[0];	// umbgxNg̐
	body.NurbsS[TypeCount[_NURBSS]].N[1] = body.NurbsS[TypeCount[_NURBSS]].K[1] + body.NurbsS[TypeCount[_NURBSS]].M[1];	// vmbgxNg̐
	for(i=0;i<5;i++){
		body.NurbsS[TypeCount[_NURBSS]].prop[i] = CatchStringI(&p);	// u[A^vpeB5
	}

	// [m
	if(NFunc.New_NurbsS(&body.NurbsS[TypeCount[_NURBSS]],body.NurbsS[TypeCount[_NURBSS]].K,body.NurbsS[TypeCount[_NURBSS]].N) == KOD_ERR){
		SetMessage("PARAMETER SECTION KOD_ERROR:fail to allocate memory");
		return KOD_ERR;
	}
	
	for(i=0;i<body.NurbsS[TypeCount[_NURBSS]].N[0];i++){
		body.NurbsS[TypeCount[_NURBSS]].S[i] = CatchStringD(&p);	// umbgxNg
	}
	for(i=0;i<body.NurbsS[TypeCount[_NURBSS]].N[1];i++){
		body.NurbsS[TypeCount[_NURBSS]].T[i] = CatchStringD(&p);	// vmbgxNg
	}
	for(i=0;i<body.NurbsS[TypeCount[_NURBSS]].K[1];i++){
		for(j=0;j<body.NurbsS[TypeCount[_NURBSS]].K[0];j++){
			body.NurbsS[TypeCount[_NURBSS]].W[j][i] = CatchStringD(&p);	//  uWeight
		}
	}
	for(i=0;i<body.NurbsS[TypeCount[_NURBSS]].K[1];i++){
		for(j=0;j<body.NurbsS[TypeCount[_NURBSS]].K[0];j++){
			body.NurbsS[TypeCount[_NURBSS]].cp[j][i].x = CatchStringD(&p);	// Rg[|CgX
			body.NurbsS[TypeCount[_NURBSS]].cp[j][i].y = CatchStringD(&p);	// Rg[|CgY
			body.NurbsS[TypeCount[_NURBSS]].cp[j][i].z = CatchStringD(&p);	// Rg[|CgZ
		}
	}
	body.NurbsS[TypeCount[_NURBSS]].U[0] = CatchStringD(&p);			// ůJnl
	body.NurbsS[TypeCount[_NURBSS]].U[1] = CatchStringD(&p);			// ȕIl
	body.NurbsS[TypeCount[_NURBSS]].V[0] = CatchStringD(&p);			// v̊Jnl
	body.NurbsS[TypeCount[_NURBSS]].V[1] = CatchStringD(&p);			// v̏Il

	body.NurbsS[TypeCount[_NURBSS]].pD = pD;		// DEւ̋t|C^̒l

	body.NurbsS[TypeCount[_NURBSS]].TrmdSurfFlag = KOD_FALSE;	// Ƃ肠gĂȂƗʂƂĂ(Type144ǂ݂ɌƂɕύX)

	body.ChangeStatColor(body.NurbsS[TypeCount[_NURBSS]].Dstat.Color,0.2,0.2,0.2,0.5);	// Ȗʂ̐Fݒ

	return KOD_TRUE;
}

// Type102 Ȑ̓ǂݍ
int IGES_PARSER::GetCompCPara(char str[],int pD,DirectoryParam *dpara,int dline,BODY body)
{
	char *p;
	int  pdnum;		// DẼV[PXio[擾p
	int  i;

	p = str;

	body.CompC[TypeCount[_COMPOSITE_CURVE]].N = CatchStringI(&p);	// Ȑ̍\vf

	// Ȑ̃[m
	if(NFunc.New_CompC(&body.CompC[TypeCount[_COMPOSITE_CURVE]],body.CompC[TypeCount[_COMPOSITE_CURVE]].N) == KOD_ERR){
		SetMessage("PARAMETER SECTION KOD_ERROR:fail to allocate memory");
		return KOD_ERR;
	}

	for(i=0;i<body.CompC[TypeCount[_COMPOSITE_CURVE]].N;i++){		// \vfDEւ̃|C^l
		pdnum = CatchStringI(&p);		// e\vfDẼV[PXio[𓾂
		body.CompC[TypeCount[_COMPOSITE_CURVE]].DEType[i] = SearchEntType(dpara,pdnum,dline);		// pdnumGeBeB^Cv𔻕
		body.CompC[TypeCount[_COMPOSITE_CURVE]].pDE[i] = (COMPELEM *)GetDEPointer(pdnum,body);		// pdnum\̂̃|C^𓾂
	}

	body.CompC[TypeCount[_COMPOSITE_CURVE]].pD = pD;		// DEւ̋t|C^̒l

	return KOD_TRUE;
}

// Type142 ʏ̓ǂݍ
int IGES_PARSER::GeConpSPara(char str[],int pD,DirectoryParam *dpara,int dline,BODY body)
{
	char *p;
	int pdnum;		// DẼV[PXio[擾p

	p = str;

	body.ConpS[TypeCount[_CURVE_ON_PARAMETRIC_SURFACE]].crtn = CatchStringI(&p);	// ʏǂ̂悤ɍꂽ\

	pdnum = CatchStringI(&p);			// CurveSurfaceDẼV[PXio[𓾂
	body.ConpS[TypeCount[_CURVE_ON_PARAMETRIC_SURFACE]].SType = SearchEntType(dpara,pdnum,dline);	// pdnumGeBeB^Cv𔻕
	body.ConpS[TypeCount[_CURVE_ON_PARAMETRIC_SURFACE]].pS = (NURBSS *)GetDEPointer(pdnum,body);		// pdnum\̂̃|C^𓾂

	pdnum = CatchStringI(&p);			// Surfacẽp[^Ԃɂcurve`EntityDẼV[PXio[𓾂
	body.ConpS[TypeCount[_CURVE_ON_PARAMETRIC_SURFACE]].BType = SearchEntType(dpara,pdnum,dline);	// pdnumGeBeB^Cv𔻕
	body.ConpS[TypeCount[_CURVE_ON_PARAMETRIC_SURFACE]].pB = (CURVE *)GetDEPointer(pdnum,body);		// pdnum\̂̃|C^𓾂(p)

	pdnum = CatchStringI(&p);			// Curve CDEւ̃|C^
	body.ConpS[TypeCount[_CURVE_ON_PARAMETRIC_SURFACE]].CType = SearchEntType(dpara,pdnum,dline);	// pdnumGeBeB^Cv𔻕
	body.ConpS[TypeCount[_CURVE_ON_PARAMETRIC_SURFACE]].pC = (CURVE *)GetDEPointer(pdnum,body);		// pdnum\̂̃|C^𓾂(p)

	body.ConpS[TypeCount[_CURVE_ON_PARAMETRIC_SURFACE]].pref = CatchStringI(&p);	// 葤VXeō̂Ă\\tO

	body.ConpS[TypeCount[_CURVE_ON_PARAMETRIC_SURFACE]].pD = pD;	// DẼV[PXio[𓾂

	return KOD_TRUE;
}

// Type144 gʂ̓ǂݍ
int IGES_PARSER::GetTrmSPara(char str[],int pD,DirectoryParam *dpara,BODY body)
{
	char *p;
	int  i;
	int  pdnum;		// DẼV[PXio[擾p

	p = str;
	
	pdnum = CatchStringI(&p);		// gSurface EntityDE̒l擾
	body.TrmS[TypeCount[_TRIMMED_SURFACE]].pts = (NURBSS *)GetDEPointer(pdnum,body);		// gSurface Entityւ̃|C^擾
	body.TrmS[TypeCount[_TRIMMED_SURFACE]].pts->TrmdSurfFlag = KOD_TRUE;		// gʂƂĂNURBSȖʂł邱Ƃ
	body.TrmS[TypeCount[_TRIMMED_SURFACE]].n1 = CatchStringI(&p);		// OFOD̋EƈvĂ@PFȊO
	body.TrmS[TypeCount[_TRIMMED_SURFACE]].n2 = CatchStringI(&p);		// Trimmed Surface̓̒PȐ̐

	pdnum = CatchStringI(&p);		// Trimmed Surface̊O̒PȐ̐
	body.TrmS[TypeCount[_TRIMMED_SURFACE]].pTO = (CONPS *)GetDEPointer(pdnum,body); // PȐ\̂ւ̃|C^擾

	// PȐN2̐[m
	if((NFunc.New_TrmS(&body.TrmS[TypeCount[_TRIMMED_SURFACE]],body.TrmS[TypeCount[_TRIMMED_SURFACE]].n2)) == KOD_ERR){
		SetMessage("PARAMETER SECTION KOD_ERROR:fail to allocate memory");
		return KOD_ERR;
	}

	for(i=0;i<body.TrmS[TypeCount[_TRIMMED_SURFACE]].n2;i++){
		pdnum = CatchStringI(&p);	// Trimmed Surface̓̒PȐDE̒l擾
		body.TrmS[TypeCount[_TRIMMED_SURFACE]].pTI[i] = (CONPS *)GetDEPointer(pdnum,body);	// PȐ\̂ւ̃|C^擾
	}

	body.TrmS[TypeCount[_TRIMMED_SURFACE]].pD = pD;		// DẼV[PXio[𓾂

	return KOD_TRUE;
}


// fBNgǂݍ
int IGES_PARSER::GetDirectorySection(FILE *fp,DirectoryParam *dpara,int TypeNum[],int dline)
{
	int i,j;
	char *p;						// 擪ʗp|C^
	char str[COLUMN_MAX*2+1];		// 2si1GeBeBj̕z
	char field[FIELD_NUM+1];		// 81tB[h
	char dmy;

	for(i=0;i<ALL_ENTITY_TYPE_NUM;i++){
		TypeNum[i] = 0;			// 
	}

	for(i=0;i<dline;i++){
		strcpy(str,"");				// str

		if(fgets(buf,COLUMN_MAX_,fp) == NULL){		// iԖڂ̃GeBeB1sڂǂݍ
			SetMessage("DIRECTORY SECTION KOD_ERROR: fail to read this file");
			exit(KOD_ERR);
		}
		strncat(str,buf,COLUMN_MAX);
		if(fgets(buf,COLUMN_MAX_,fp) == NULL){		// iԖڂ̃GeBeB2sڂǂݍ
			SetMessage("DIRECTORY SECTION KOD_ERROR: fail to read this file");
			exit(KOD_ERR);
		}
		strncat(str,buf,COLUMN_MAX);				// ǂݍ2sstrɑSĊi[

		p = str;									// p܂str̐擪ɂ
		for(j=0;j<DIRECTORYPARANUM;j++){			// fBNg̃p[^̐[v
			strncpy(field,p,8);						// p̐擪8field֊i[
			field[FIELD_NUM] = '\0';				// ꉞAI[field̂KɂĂ
			p += FIELD_NUM;							// p̃tB[h̐擪ֈړ
			// fBNg̏񂪕Kvȏꍇ͈ȉɃR[hǉ
			if(j == ENTITY_TYPE_NUM){					// vfԍ擾
				dpara[i].entity_type = atoi(field);
				GetType(dpara[i].entity_type,TypeNum);	// GeBeB^Cv̐Z
			}
			else if(j == PARAM_DATA){					// p[^ւ̃|C^擾
				dpara[i].p_param = atoi(field);
			}
			else if(j == TRAN_MATRIX){					// }gbNXւ̃|C^擾
				dpara[i].p_tm = atoi(field);
			}
			else if(j == STATUS_NUM){					// Xe[^X擾
				GetStatusNumber(field,&dpara[i]);
			}
			else if(j == SEQUENCE_NUM){					// V[PXԍ擾
				sscanf(field,"%c %d",&dmy,&dpara[i].seq_num);
			}
			else if(j == PARAM_LINE_COUNT){				// p[^̃C
				dpara[i].param_line_count = atoi(field);
			}
		}
	}
	
	return KOD_TRUE;
}

// GeBeB^Cv̐Z
void IGES_PARSER::GetType(int type,int entitynum[])
{
	int i;

	// ܂͉~E~ʃGeBeB̏ꍇNURBSȐGeBeBɃCNg
	if(type == LINE || type == CIRCLE_ARC){
		entitynum[_NURBSC]++;
	}

	for(i=0;i<ALL_ENTITY_TYPE_NUM;i++){
		if(type == entity[i]){
			entitynum[i]++;		// ienum^EntityTypɑΉ ex) entitynum[10]_NURBSCiLBXvCȐj̐\
		}
	}
}

// DE#9(Xe[^X)̓ǂݍ
void IGES_PARSER::GetStatusNumber(char field[],DirectoryParam *dpara)
{
	char str[3]="";
	char *p;

	p = field;
	strncpy(str,p,2);
	sscanf(str,"%d",&dpara->blank_stat);
	p += 2;
	strncpy(str,p,2);
	sscanf(str,"%d",&dpara->subordinate_stat);
	p += 2;
	strncpy(str,p,2);
	sscanf(str,"%d",&dpara->useflag_stat);
	p += 2;
}

// O[oǂݍ
int IGES_PARSER::GetGlobalSection(FILE *fp,GlobalParam *gpara,int gline)
{
	char *str;					// O[oSĂi[
	char para_delim = ',';		// p[^f~^
	char record_delim = ';';	// R[hf~^
	int  para_length;			// ep[^̒̕i[
	char *p;
	int  i;

	// O[õC*COL_CHAR[m
	str = (char *)malloc(sizeof(char) * gline*COL_CHAR);
	if(str == NULL){
		SetMessage("GLOBAL SECTION KOD_ERROR: faile to allocate memory");
		exit(KOD_ERR);
	}

	strcpy(str,"");			// str
	for(i=0;i<gline;i++){
		if(fgets(buf,COLUMN_MAX_,fp) == NULL){
			SetMessage("GLOBAL SECTION KOD_ERROR: faile to read this file");
			exit(KOD_ERR);
		}
		strncat(str,buf,COL_CHAR-1);	// strɃZNVʕ܂ł̕Ă
	}

	// p[^f~^ƃR[hf~^̃`FbN
	sscanf(str,"%dH%c",&para_length,&para_delim);		// p[^f~^擾
	if(para_delim != ','){
		SetMessage("GLOBAL SECTION KOD_ERROR: The parameter delimiter is not governed by and construed for JAMA-IS");
		exit(KOD_ERR);
	}
	else{
		sscanf(str,"%dH[^,],[^,],%dH%c",&para_length,&para_length,&record_delim);		// R[hf~^擾
		if(record_delim != ';'){
			SetMessage("GLOBAL SECTION KOD_ERROR: The record delimiter is not governed by and construed for JAMA-IS");
			exit(KOD_ERR);
		}
	}

	p = str;
	p += 4;		// pstr5ځip[^f~^`̎j܂ňړ
	p = strtok(p,",");
	for(i=3;i<=GLOBALPARAMNUM;i++){		// 2̃f~^𔲂c̃p[^𒀎ǂݍ
		if((p = strtok(NULL,",")) == NULL && i<GLOBALPARAMNUM){
			SetMessage("GLOBAL SECTION KOD_ERROR: Low parameter count of global section");
			exit(KOD_ERR);
		}

		// O[ȍ񂪕Kvȏꍇ͈ȉɃR[hL
		if(i == MODEL_SCALE){				// fXP[ǂݍ
			gpara->scale = atof(p);
		}
		else if(i == UNIT_FLAG){			// PʃtOǂݍ
			gpara->unit_flag = atoi(p);
		}
		else if(i == MODEL_SPACE_SIZE){		// fԂ̑傫ǂݍ
			gpara->space_size = atof(p);
		}
	}

	free(str);		// [J

	return KOD_TRUE;
}

// X^[gǂݍ
int IGES_PARSER::GetStartSection(FILE *fp,int sline)
{
	int i;

	for(i=0;i<sline;i++){
		if(fgets(buf,COLUMN_MAX_,fp) == NULL){
			SetMessage("START SECTION KOD_ERROR:fail to read this file");
			exit(KOD_ERR);
		}

		// X^[g̏񂪕Kvȏꍇ͈ȉɃR[hǉ
	}

	return KOD_TRUE;
}

// ^[~l[gǂݍ
int IGES_PARSER::GetTerminateSection(FILE *fp)
{
	return KOD_TRUE;
}

// eZNṼC𒲂ׂ
void IGES_PARSER::GetSectionLine(FILE *fp,int line[])
{
	line[0] = line[1] = line[2] = line[3] = line[4] = 0;	// 

	while(fgets(buf,COLUMN_MAX_,fp)){
		if(buf[COL_CHAR-1] == 'S'){
			line[SECTION_START]++;
		}
		else if(buf[COL_CHAR-1] == 'G'){
			line[SECTION_GLOBAL]++;
		}
		else if(buf[COL_CHAR-1] == 'D'){
			line[SECTION_DIRECTORY]++;
		}
		else if(buf[COL_CHAR-1] == 'P'){
			line[SECTION_PARAMETER]++;
		}
		else if(buf[COL_CHAR-1] == 'T'){
			line[SECTION_TERMINATE]++;
		}
		else{							// ǂ̃ZNVɂȂo
			SetMessage("KOD_ERROR: IGES FORMAT");
			exit(KOD_ERR);
		}
	}
	fseek(fp,0L,SEEK_SET);				// t@C擪ɖ߂

}

// J}܂ł̐lǂݍŕԂ(int)
int IGES_PARSER::CatchStringI(char **p)
{
	int a;

	if((*p = strchr(*p,',')) == NULL){
		SetMessage("KOD_ERROR:No governed by and construed for JAMA-IS");
		exit(KOD_ERR);
	}

	(*p)++;
	sscanf(*p,"%d[^,],",&a);

	return a;
}

// J}܂ł̐lǂݍŕԂ(double)
double IGES_PARSER::CatchStringD(char **p)
{
	double a;

	if((*p = strchr(*p,',')) == NULL){
		SetMessage("KOD_ERROR:No governed by and construed for JAMA-IS");
		exit(KOD_ERR);
	}

	(*p)++;
	sscanf(*p,"%lf[^,],",&a);

	return a;
}

// DEւ̃|C^ۂ̍\̂ւ̃|C^Ԃ
void *IGES_PARSER::GetDEPointer(int TypeNum,BODY body)
{
	int i,j;

	for(i=0;i<ALL_ENTITY_TYPE_NUM;i++){
		for(j=0;j<TypeCount[i];j++){
			if(i==_CIRCLE_ARC && body.CirA[j].pD == TypeNum){
				return &body.CirA[j];
			}
			else if(i==_COMPOSITE_CURVE && body.CompC[j].pD == TypeNum){
				return &body.CompC[j];
			}
			else if(i==_CONIC_ARC && body.ConA[j].pD == TypeNum){
				return &body.ConA[j];
			}
			else if(i==_LINE && body.Line[j].pD == TypeNum){
				return &body.Line[j];
			}
			else if(i==_TRANSFORMATION_MATRIX && body.TMat[j].pD == TypeNum){
				return &body.TMat[j];
			}
			else if(i==_NURBSC && body.NurbsC[j].pD == TypeNum){
				return &body.NurbsC[j];
			}
			else if(i==_NURBSS && body.NurbsS[j].pD == TypeNum){
				return &body.NurbsS[j];
			}
			else if(i==_CURVE_ON_PARAMETRIC_SURFACE && body.ConpS[j].pD == TypeNum){
				return &body.ConpS[j];
			}
			else if(i==_TRIMMED_SURFACE && body.TrmS[j].pD == TypeNum){
				return &body.TrmS[j];
			}
		}
	}

	return NULL;
}

// DEւ̃|C^̒lGeBeB̃^Cv𒲂ׂĕԂ
int IGES_PARSER::SearchEntType(DirectoryParam *dpara,int pdnum,int dline)
{
	int i;

	for(i=0;i<dline;i++){
		if(dpara[i].seq_num == pdnum){
			return dpara[i].entity_type;
		}
	}

	return KOD_ERR;
}
// SẴGeBeBɂWl̍ől𒲂ׂ
int IGES_PARSER::SearchMaxCoord(BODY *body,int TypeNum[])
{
	int i,j;
	int temp=0;
	int bufnum=0;
	double *CoordBuf;
	
	// #100(~A~)A#110()A#126(NURBSȐ)̃Rg[|Cg̍Wľ𓾂
	for(i=0;i<TypeNum[_NURBSC];i++){
		bufnum += 3*body->NurbsC[i].K;
	}
	
	// m
	if((CoordBuf = (double*)malloc(sizeof(double)*bufnum)) == NULL){
		SetMessage("SEARCH MAXCOORD KOD_ERROR:fail to allocate memory");
		return KOD_ERR;
	}

	// #100(~A~)A#110()A#126(NURBSȐ)̃Rg[|Cg̍Wl𓾂
	for(i=0;i<TypeNum[_NURBSC];i++){
		for(j=0;j<body->NurbsC[i].K;j++){
			CoordBuf[temp*3] = fabs(body->NurbsC[i].cp[j].x);	// Rg[|CgX
			CoordBuf[temp*3+1] = fabs(body->NurbsC[i].cp[j].y);	// Rg[|CgY
			CoordBuf[temp*3+2] = fabs(body->NurbsC[i].cp[j].z);	// Rg[|CgZ
			temp++;
		}
	}
	
	qsort(CoordBuf,bufnum,sizeof(double),QCmp);	// SĂ̍WlNCbN\[gɂ~Ƀ\[g
	body->MaxCoord = CoordBuf[0];				// ł傫Wl𓾂

	// 
	free(CoordBuf);
	
	return KOD_TRUE;
}

// RXgN^
IGES_PARSER::IGES_PARSER()
{
		entity[0] = CIRCLE_ARC;							// ~/~
		entity[1] = COMPOSITE_CURVE;					// Ȑ
		entity[2] = CONIC_ARC;							// ~Ȑ
		entity[3] = COPIOUS_DATA;						// Lӓ_
		entity[4] = PLANE;								// 
		entity[5] = LINE;								// 
		entity[6] = PARAMETRIC_SPLINE_CURVE;			// pgbNXvCȐ
		entity[7] = PARAMETRIC_SPLINE_SURFACE;			// pgbNXvCȖ
		entity[8] = POINT;								// _
		entity[9] = TRANSFORMATION_MATRIX;				// ϊs
		entity[10] = NURBS_CURVE;						// LBXvCȐ
		entity[11] = NURBS_SURFACE;						// LBXvCȖ
		entity[12] = CURVE_ON_PARAMETRIC_SURFACE; 		// ʏ
		entity[13] = TRIMMED_SURFACE;					// g
		entity[14] = SUBFIGURE_DEFINITION;				// q}̒`
		entity[15] = ASSOCIATIVITY_INSTANCE;			// O[v
		entity[16] = DRAWING;							// }
		entity[17] = PROPERTY;							// }ʃTCY
		entity[18] = SINGULAR_SUBFIGURE_INSTANCE;		// q}̎Q
		entity[19] = VIEW;								// ۖ
}

// eGeBeB̕\ݒ
void IGES_PARSER::InitDisplayStat(DispStat *Dstat)
{
	// Fݒ
	Dstat->Color[0] = 1.0;
	Dstat->Color[1] = 1.0;
	Dstat->Color[2] = 1.0;
	Dstat->Color[3] = 0.5;

	// \ǉꍇ͈ȉɒǉ̃R[hLq
}

// Type110()Type126(NURBSȐ)̃p[^𓾂
int IGES_PARSER::GetNurbsCFromLine(int NurbsCount,int LineCount,BODY body)	
{
	int i=0;
	int KOD_ERRflag=0;

	body.NurbsC[NurbsCount].K = 2;		// aL̏㑤YiRg[|Cg-1j̒l
	body.NurbsC[NurbsCount].M = 2;		// ֐̊K
	body.NurbsC[NurbsCount].N = body.NurbsC[NurbsCount].K + body.NurbsC[NurbsCount].M;	// mbgxNg̐

	// u[A^vpeB4
	body.NurbsC[NurbsCount].prop[0] = 0;
	body.NurbsC[NurbsCount].prop[1] = 0;
	body.NurbsC[NurbsCount].prop[2] = 1;
	body.NurbsC[NurbsCount].prop[3] = 0;

	// [m
	KOD_ERRflag++;	// 1
	if((body.NurbsC[NurbsCount].T = (double *)malloc(sizeof(double)*body.NurbsC[NurbsCount].N)) == NULL){
		goto EXIT;
	}
	KOD_ERRflag++;	// 2
	if((body.NurbsC[NurbsCount].W = (double *)malloc(sizeof(double)*body.NurbsC[NurbsCount].K)) == NULL){
		goto EXIT;
	}
	KOD_ERRflag++;	// 3
	if((body.NurbsC[NurbsCount].cp = (Coord *)malloc(sizeof(Coord)*body.NurbsC[NurbsCount].K)) == NULL){
		goto EXIT;
	}

	// mbgxNg̒l	
	body.NurbsC[NurbsCount].T[0] = 0.;
	body.NurbsC[NurbsCount].T[1] = 0.;
	body.NurbsC[NurbsCount].T[2] = 1.;
	body.NurbsC[NurbsCount].T[3] = 1.;
	
	for(i=0;i<body.NurbsC[NurbsCount].K;i++){				// Weight̒l
		body.NurbsC[NurbsCount].W[i] = 1.;
	}
	for(i=0;i<body.NurbsC[NurbsCount].K;i++){				// Rg[|Cg̍Wl
		body.NurbsC[NurbsCount].cp[i].x = body.Line[LineCount].cp[i].x;
		body.NurbsC[NurbsCount].cp[i].y = body.Line[LineCount].cp[i].y;
		body.NurbsC[NurbsCount].cp[i].z = body.Line[LineCount].cp[i].z;
	}
	
	// p[^̒l
	body.NurbsC[NurbsCount].V[0] = 0.;
	body.NurbsC[NurbsCount].V[1] = 1.;

	InitDisplayStat(&body.NurbsC[NurbsCount].Dstat);	// \̏

	return KOD_TRUE;

	// [mۂɎsꍇ͍܂ŊmۂJKOD_ERRԂ
EXIT:
		SetMessage("PARAMETER SECTION KOD_ERROR:fail to allocate memory");
	if(KOD_ERRflag == 3){
		free(body.NurbsC[NurbsCount].cp);
		KOD_ERRflag--;
	}
	if(KOD_ERRflag == 2){
		free(body.NurbsC[NurbsCount].W);
		KOD_ERRflag--;
	}
	if(KOD_ERRflag == 1){
		free(body.NurbsC[NurbsCount].T);
	}
	return KOD_ERR;
}

// Type110(~E~)Type126(NURBSȐ)̃p[^f[^𓾂
int IGES_PARSER::GetNurbsCFromCirA(int NurbsCount,int CirCount,BODY body)	
{
	int	 flag=KOD_TRUE;
	double	angle_deg = 0.0,
			angle_rad = 0.0,
			radius = 0.0;
	Coord	vec[2];
	
	// ~/~ʂ̒S_O-n_PsxNgAS_-I_PexNgꂼꋁ߂
	vec[0] = SubCoord(body.CirA[CirCount].cp[1],body.CirA[CirCount].cp[0]);
	vec[1] = SubCoord(body.CirA[CirCount].cp[2],body.CirA[CirCount].cp[0]);	

	radius = body.CirA[CirCount].R;	// ~/~ʂ̒S_Ǝn_̋(a)
	angle_rad = CalcVecAngle2D(vec[0],vec[1]);			// ~/~ʂ𐬂Sp̑傫(degree)߂
	angle_deg = RadToDeg(angle_rad);				// ~/~ʂ𐬂Sp̑傫(radian)߂

	// Sp(degree)̑傫ƂɃZOgύX
	if( angle_deg > 0 && angle_deg <= 90 ){								// 0<<=90
		flag = CirAToNurbsC_seg1(NurbsCount ,CirCount , body, vec, angle_rad);		// 1ZOg
	}
	else if( angle_deg > 90 && angle_deg <= 270 ){						// 90<<=270
		flag = CirAToNurbsC_seg2(NurbsCount ,CirCount , body, vec, angle_rad);		// 2ZOg
	}
	else if( angle_deg > 270 && angle_deg < 360 ){						// 270<<360
		flag = CirAToNurbsC_seg3(NurbsCount ,CirCount , body, vec, angle_rad);		// 3ZOg
	}
	else if( angle_deg == 0 ){											// =0(360)
		flag = CirAToNurbsC_seg4(NurbsCount ,CirCount , body, vec, radius);			//@4ZOg
	}
	else{
		SetMessage("Center angle of a circle or circular arc is not calculated normally");
		return KOD_ERR;
	}

	return KOD_TRUE;
}

// 1ZOg̉~(Sp0<<=90̎)
int IGES_PARSER::CirAToNurbsC_seg1(int NurbsCount,int CirCount,BODY body,Coord vec[], double angle_rad)
{
	int i=0;
	int KOD_ERRflag=0;
	
	Coord	vec_cp;
	
	body.NurbsC[NurbsCount].K = 3;		// aL̏㑤YiRg[|Cg-1j̒l
	body.NurbsC[NurbsCount].M = 3;		// ֐̊K
	body.NurbsC[NurbsCount].N = body.NurbsC[NurbsCount].K + body.NurbsC[NurbsCount].M;	// mbgxNg̐

	// u[A^vpeB4
	body.NurbsC[NurbsCount].prop[0] = 0;
	body.NurbsC[NurbsCount].prop[1] = 0;
	body.NurbsC[NurbsCount].prop[2] = 1;
	body.NurbsC[NurbsCount].prop[3] = 0;
	
	// [m
	KOD_ERRflag++;	// 1
	if((body.NurbsC[NurbsCount].T = (double *)malloc(sizeof(double)*body.NurbsC[NurbsCount].N)) == NULL){
		goto EXIT;
	}
	KOD_ERRflag++;	// 2
	if((body.NurbsC[NurbsCount].W = (double *)malloc(sizeof(double)*body.NurbsC[NurbsCount].K)) == NULL){
		goto EXIT;
	}
	KOD_ERRflag++;	// 3
	if((body.NurbsC[NurbsCount].cp = (Coord *)malloc(sizeof(Coord)*body.NurbsC[NurbsCount].K)) == NULL){
		goto EXIT;
	}
	
	// mbgxNg̒l	
	body.NurbsC[NurbsCount].T[0] = 0.;
	body.NurbsC[NurbsCount].T[1] = 0.;
	body.NurbsC[NurbsCount].T[2] = 0.;
	body.NurbsC[NurbsCount].T[3] = 1.;
	body.NurbsC[NurbsCount].T[4] = 1.;
	body.NurbsC[NurbsCount].T[5] = 1.;
		
	// Weight̒l
	for(i=0; i<3; i++){
		if(i % 2 == 0){
			body.NurbsC[NurbsCount].W[i] = 1.;
		}	
		else if(i % 2 == 1){	
			body.NurbsC[NurbsCount].W[i] = cos(angle_rad/2);
		}
	}
		
	vec_cp = Arc_CP(vec[0], vec[1], cos(angle_rad));	//@~̒S_Rg[|CgP1ւ̃xNg߂
	
	// Rg[|Cg̍Wl
	body.NurbsC[NurbsCount].cp[0].x = body.CirA[CirCount].cp[1].x;
	body.NurbsC[NurbsCount].cp[0].y = body.CirA[CirCount].cp[1].y;		
	body.NurbsC[NurbsCount].cp[1].x = vec_cp.x + body.CirA[CirCount].cp[0].x;
	body.NurbsC[NurbsCount].cp[1].y = vec_cp.y + body.CirA[CirCount].cp[0].y;
	body.NurbsC[NurbsCount].cp[2].x = body.CirA[CirCount].cp[2].x;
	body.NurbsC[NurbsCount].cp[2].y = body.CirA[CirCount].cp[2].y;

	for(i=0; i<3; i++){
		body.NurbsC[NurbsCount].cp[i].z = body.CirA[CirCount].zt;	// Z̑傫͈
	}
		
	body.NurbsC[NurbsCount].V[0] = 0.;		// p[^̒l
	body.NurbsC[NurbsCount].V[1] = 1.;

	InitDisplayStat(&body.NurbsC[NurbsCount].Dstat);
		  
	return KOD_TRUE;

	// [mۂɎsꍇ͍܂ŊmۂJKOD_ERRԂ
EXIT:
		SetMessage("PARAMETER SECTION KOD_ERROR:fail to allocate memory");
	if(KOD_ERRflag == 3){
		free(body.NurbsC[NurbsCount].cp);
		KOD_ERRflag--;
	}
	if(KOD_ERRflag == 2){
		free(body.NurbsC[NurbsCount].W);
		KOD_ERRflag--;
	}
	if(KOD_ERRflag == 1){
		free(body.NurbsC[NurbsCount].T);
	}
	return KOD_ERR;
}

// 2ZOg̉~(Sp90<<=270̎)
int IGES_PARSER::CirAToNurbsC_seg2(int NurbsCount,int CirCount,BODY body,Coord vec[], double angle_rad)
{
	int	i = 0,
		KOD_ERRflag = 0;
	double	angle_rad2 = 0.0;
	
	Coord vec_cp[3];
	
	body.NurbsC[NurbsCount].K = 5;		// aL̏㑤YiRg[|Cg-1j̒l
	body.NurbsC[NurbsCount].M = 3;		// ֐̊K
	body.NurbsC[NurbsCount].N = body.NurbsC[NurbsCount].K + body.NurbsC[NurbsCount].M;	// mbgxNg̐
	// u[A^vpeB4
	body.NurbsC[NurbsCount].prop[0] = 0;
	body.NurbsC[NurbsCount].prop[1] = 0;
	body.NurbsC[NurbsCount].prop[2] = 1;
	body.NurbsC[NurbsCount].prop[3] = 0;
	
	// [m
	KOD_ERRflag++;	// 1
	if((body.NurbsC[NurbsCount].T = (double *)malloc(sizeof(double)*body.NurbsC[NurbsCount].N)) == NULL){
		goto EXIT;
	}
	KOD_ERRflag++;	// 2
	if((body.NurbsC[NurbsCount].W = (double *)malloc(sizeof(double)*body.NurbsC[NurbsCount].K)) == NULL){
		goto EXIT;
	}
	KOD_ERRflag++;	// 3
	if((body.NurbsC[NurbsCount].cp = (Coord *)malloc(sizeof(Coord)*body.NurbsC[NurbsCount].K)) == NULL){
		goto EXIT;
	}
	
	// mbgxNg̒l	
	body.NurbsC[NurbsCount].T[0] = 0.;
	body.NurbsC[NurbsCount].T[1] = 0.;
	body.NurbsC[NurbsCount].T[2] = 0.;
	body.NurbsC[NurbsCount].T[3] = 2./4.;
	body.NurbsC[NurbsCount].T[4] = 2./4.;
	body.NurbsC[NurbsCount].T[5] = 1.;
	body.NurbsC[NurbsCount].T[6] = 1.;
	body.NurbsC[NurbsCount].T[7] = 1.;
		
	// Weight̒l
	for(i=0; i<5; i++){
		if(i % 2 == 0){
			body.NurbsC[NurbsCount].W[i] = 1.;
		}	
		else if(i % 2 == 1){	
			body.NurbsC[NurbsCount].W[i] = cos(angle_rad/4);
		}
	}
		
	angle_rad2 = angle_rad/2;	// (Sp)2
	
	vec_cp[1] = CalcRotVec2D(vec[0], angle_rad2);		// ~̒S_璆Sp̔̈ʒu(Rg[|CgP2)ւ̃xNg߂
	vec_cp[0] = Arc_CP(vec[0], vec_cp[1], cos(angle_rad2));	// ~̒S_Rg[|CgP1ւ̃xNg߂
	vec_cp[2] = Arc_CP(vec_cp[1], vec[1], cos(angle_rad2));	// ~̒S_Rg[|CgP3ւ̃xNg߂
	
	// Rg[|Cg̍Wl
	body.NurbsC[NurbsCount].cp[0].x = body.CirA[CirCount].cp[1].x;
	body.NurbsC[NurbsCount].cp[0].y = body.CirA[CirCount].cp[1].y;		
 	body.NurbsC[NurbsCount].cp[1].x = vec_cp[0].x + body.CirA[CirCount].cp[0].x;
 	body.NurbsC[NurbsCount].cp[1].y = vec_cp[0].y + body.CirA[CirCount].cp[0].y;
 	body.NurbsC[NurbsCount].cp[2].x = vec_cp[1].x + body.CirA[CirCount].cp[0].x;
 	body.NurbsC[NurbsCount].cp[2].y = vec_cp[1].y + body.CirA[CirCount].cp[0].y;
 	body.NurbsC[NurbsCount].cp[3].x = vec_cp[2].x + body.CirA[CirCount].cp[0].x;
 	body.NurbsC[NurbsCount].cp[3].y = vec_cp[2].y + body.CirA[CirCount].cp[0].y;
 	body.NurbsC[NurbsCount].cp[4].x = body.CirA[CirCount].cp[2].x;
 	body.NurbsC[NurbsCount].cp[4].y = body.CirA[CirCount].cp[2].y;
	for(i=0; i<5; i++){
		body.NurbsC[NurbsCount].cp[i].z = body.CirA[CirCount].zt;	// Z̑傫͈
	}
	
	body.NurbsC[NurbsCount].V[0] = 0.;		// p[^̒l
	body.NurbsC[NurbsCount].V[1] = 1.;

	InitDisplayStat(&body.NurbsC[NurbsCount].Dstat);
		  
	return KOD_TRUE;

	// [mۂɎsꍇ͍܂ŊmۂJKOD_ERRԂ
EXIT:
		SetMessage("PARAMETER SECTION KOD_ERROR:fail to allocate memory");
	if(KOD_ERRflag == 3){
		free(body.NurbsC[NurbsCount].cp);
		KOD_ERRflag--;
	}
	if(KOD_ERRflag == 2){
		free(body.NurbsC[NurbsCount].W);
		KOD_ERRflag--;
	}
	if(KOD_ERRflag == 1){
		free(body.NurbsC[NurbsCount].T);
	}
	return KOD_ERR;
}

// 3ZOg̉~(Sp270<<360̎)
int IGES_PARSER::CirAToNurbsC_seg3(int NurbsCount,int CirCount,BODY body,Coord vec[], double angle_rad)
{
	int	i=0,
		KOD_ERRflag=0;
	double	angle_rad3 = 0.0;
	
	Coord	vec_cp[5];
	
	body.NurbsC[NurbsCount].K = 7;		// aL̏㑤YiRg[|Cg-1j̒l
	body.NurbsC[NurbsCount].M = 3;		// ֐̊K
	body.NurbsC[NurbsCount].N = body.NurbsC[NurbsCount].K + body.NurbsC[NurbsCount].M;	// mbgxNg̐
	
	// u[A^vpeB4
	body.NurbsC[NurbsCount].prop[0] = 0;
	body.NurbsC[NurbsCount].prop[1] = 0;
	body.NurbsC[NurbsCount].prop[2] = 1;
	body.NurbsC[NurbsCount].prop[3] = 0;
	
	// [m
	KOD_ERRflag++;	// 1
	if((body.NurbsC[NurbsCount].T = (double *)malloc(sizeof(double)*body.NurbsC[NurbsCount].N)) == NULL){
		goto EXIT;
	}
	KOD_ERRflag++;	// 2
	if((body.NurbsC[NurbsCount].W = (double *)malloc(sizeof(double)*body.NurbsC[NurbsCount].K)) == NULL){
		goto EXIT;
	}
	KOD_ERRflag++;	// 3
	if((body.NurbsC[NurbsCount].cp = (Coord *)malloc(sizeof(Coord)*body.NurbsC[NurbsCount].K)) == NULL){
		goto EXIT;
	}
	
	// mbgxNg̒l	
	body.NurbsC[NurbsCount].T[0] = 0.;
	body.NurbsC[NurbsCount].T[1] = 0.;
	body.NurbsC[NurbsCount].T[2] = 0.;
	body.NurbsC[NurbsCount].T[3] = 1./3.;
	body.NurbsC[NurbsCount].T[4] = 1./3.;
	body.NurbsC[NurbsCount].T[5] = 2./3.;
	body.NurbsC[NurbsCount].T[6] = 2./3.;
	body.NurbsC[NurbsCount].T[7] = 1.;
	body.NurbsC[NurbsCount].T[8] = 1.;
	body.NurbsC[NurbsCount].T[9] = 1.;
	
	// Weight̒l
	for(i=0; i<7; i++){
		if(i % 2 == 0){
			body.NurbsC[NurbsCount].W[i] = 1.;
		}	
		else if(i % 2 == 1){	
			body.NurbsC[NurbsCount].W[i] = cos(angle_rad/6);
		}
	}

	angle_rad3 = angle_rad/3;	// (Sp)3
	
	vec_cp[1] = CalcRotVec2D(vec[0], angle_rad3);		// ~̒S_璆Sp1/3̈ʒu(Rg[|CgP2)ւ̃xNg߂
	vec_cp[0] = Arc_CP(vec[0], vec_cp[1], cos(angle_rad3));	// ~̒S_Rg[|CgP1ւ̃xNg߂
	vec_cp[3] = CalcRotVec2D(vec_cp[1], angle_rad3);		// ~̒S_璆Sp2/3̈ʒu(Rg[|CgP4)ւ̃xNg߂
	vec_cp[2] = Arc_CP(vec_cp[1], vec_cp[3], cos(angle_rad3));	// ~̒S_Rg[|CgP3ւ̃xNg߂
	vec_cp[4] = Arc_CP(vec_cp[3], vec[1], cos(angle_rad3));	// ~̒S_Rg[|CgP4ւ̃xNg߂
		
	// Rg[|Cg̍Wl
	body.NurbsC[NurbsCount].cp[0].x = body.CirA[CirCount].cp[1].x;
	body.NurbsC[NurbsCount].cp[0].y = body.CirA[CirCount].cp[1].y;		
	body.NurbsC[NurbsCount].cp[1].x = vec_cp[0].x + body.CirA[CirCount].cp[0].x;
	body.NurbsC[NurbsCount].cp[1].y = vec_cp[0].y + body.CirA[CirCount].cp[0].y;
	body.NurbsC[NurbsCount].cp[2].x = vec_cp[1].x + body.CirA[CirCount].cp[0].x;
	body.NurbsC[NurbsCount].cp[2].y = vec_cp[1].y + body.CirA[CirCount].cp[0].y;
	body.NurbsC[NurbsCount].cp[3].x = vec_cp[2].x + body.CirA[CirCount].cp[0].x;
	body.NurbsC[NurbsCount].cp[3].y = vec_cp[2].y + body.CirA[CirCount].cp[0].y;
	body.NurbsC[NurbsCount].cp[4].x = vec_cp[3].x + body.CirA[CirCount].cp[0].x;
	body.NurbsC[NurbsCount].cp[4].y = vec_cp[3].y + body.CirA[CirCount].cp[0].y;
	body.NurbsC[NurbsCount].cp[5].x = vec_cp[4].x + body.CirA[CirCount].cp[0].x;
	body.NurbsC[NurbsCount].cp[5].y = vec_cp[4].y + body.CirA[CirCount].cp[0].y;
	body.NurbsC[NurbsCount].cp[6].x = body.CirA[CirCount].cp[2].x;
	body.NurbsC[NurbsCount].cp[6].y = body.CirA[CirCount].cp[2].y;

	for(i=0; i<7; i++){
		body.NurbsC[NurbsCount].cp[i].z = body.CirA[CirCount].zt;	// Z̑傫͈
	}
		
	body.NurbsC[NurbsCount].V[0] = 0.;		// p[^̒l
	body.NurbsC[NurbsCount].V[1] = 1.;

	InitDisplayStat(&body.NurbsC[NurbsCount].Dstat);
		  
	return KOD_TRUE;

	// [mۂɎsꍇ͍܂ŊmۂJKOD_ERRԂ
EXIT:
		SetMessage("PARAMETER SECTION KOD_ERROR:fail to allocate memory");
	if(KOD_ERRflag == 3){
		free(body.NurbsC[NurbsCount].cp);
		KOD_ERRflag--;
	}
	if(KOD_ERRflag == 2){
		free(body.NurbsC[NurbsCount].W);
		KOD_ERRflag--;
	}
	if(KOD_ERRflag == 1){
		free(body.NurbsC[NurbsCount].T);
	}
	return KOD_ERR;
}

// 4ZOg̉~(~)
int IGES_PARSER::CirAToNurbsC_seg4(int NurbsCount,int CirCount,BODY body,Coord vec[], double radius)
{
	int i=0;
	int KOD_ERRflag=0;

	body.NurbsC[NurbsCount].K = 9;		// aL̏㑤YiRg[|Cg-1j̒l
	body.NurbsC[NurbsCount].M = 3;		// ֐̊K
	body.NurbsC[NurbsCount].N = body.NurbsC[NurbsCount].K + body.NurbsC[NurbsCount].M;	// mbgxNg̐
	
	// u[A^vpeB4
	body.NurbsC[NurbsCount].prop[0] = 0;
	body.NurbsC[NurbsCount].prop[1] = 0;
	body.NurbsC[NurbsCount].prop[2] = 1;
	body.NurbsC[NurbsCount].prop[3] = 0;
	
	// [m
	KOD_ERRflag++;	// 1
	if((body.NurbsC[NurbsCount].T = (double *)malloc(sizeof(double)*body.NurbsC[NurbsCount].N)) == NULL){
		goto EXIT;
	}
	KOD_ERRflag++;	// 2
	if((body.NurbsC[NurbsCount].W = (double *)malloc(sizeof(double)*body.NurbsC[NurbsCount].K)) == NULL){
		goto EXIT;
	}
	KOD_ERRflag++;	// 3
	if((body.NurbsC[NurbsCount].cp = (Coord *)malloc(sizeof(Coord)*body.NurbsC[NurbsCount].K)) == NULL){
		goto EXIT;
	}
	
	// mbgxNg̒l	
	body.NurbsC[NurbsCount].T[0] = 0.;
	body.NurbsC[NurbsCount].T[1] = 0.;
	body.NurbsC[NurbsCount].T[2] = 0.;
	body.NurbsC[NurbsCount].T[3] = 1./4.;
	body.NurbsC[NurbsCount].T[4] = 1./4.;
	body.NurbsC[NurbsCount].T[5] = 2./4.;
	body.NurbsC[NurbsCount].T[6] = 2./4.;
	body.NurbsC[NurbsCount].T[7] = 3./4.;
	body.NurbsC[NurbsCount].T[8] = 3./4.;
	body.NurbsC[NurbsCount].T[9] = 1.;
	body.NurbsC[NurbsCount].T[10] = 1.;
	body.NurbsC[NurbsCount].T[11] = 1.;
		
	// Weight̒l
	for(i=0; i<9; i++){
		if(i % 2 == 0){
			body.NurbsC[NurbsCount].W[i] = 1.;
		}	
		else if(i % 2 == 1){	
			body.NurbsC[NurbsCount].W[i] = sqrt(2.0)/2;
		}
	}

	// Rg[|Cg̍Wl
	body.NurbsC[NurbsCount].cp[0].x = body.CirA[CirCount].cp[0].x + radius;
	body.NurbsC[NurbsCount].cp[0].y = body.CirA[CirCount].cp[0].y;		
	body.NurbsC[NurbsCount].cp[1].x = body.CirA[CirCount].cp[0].x + radius;
	body.NurbsC[NurbsCount].cp[1].y = body.CirA[CirCount].cp[0].y + radius;
	body.NurbsC[NurbsCount].cp[2].x = body.CirA[CirCount].cp[0].x;
	body.NurbsC[NurbsCount].cp[2].y = body.CirA[CirCount].cp[0].y + radius;
	body.NurbsC[NurbsCount].cp[3].x = body.CirA[CirCount].cp[0].x - radius;
	body.NurbsC[NurbsCount].cp[3].y = body.CirA[CirCount].cp[0].y + radius;
	body.NurbsC[NurbsCount].cp[4].x = body.CirA[CirCount].cp[0].x - radius;
	body.NurbsC[NurbsCount].cp[4].y = body.CirA[CirCount].cp[0].y;
	body.NurbsC[NurbsCount].cp[5].x = body.CirA[CirCount].cp[0].x - radius;
	body.NurbsC[NurbsCount].cp[5].y = body.CirA[CirCount].cp[0].y - radius;
	body.NurbsC[NurbsCount].cp[6].x = body.CirA[CirCount].cp[0].x;
	body.NurbsC[NurbsCount].cp[6].y = body.CirA[CirCount].cp[0].y - radius;
	body.NurbsC[NurbsCount].cp[7].x = body.CirA[CirCount].cp[0].x + radius;
	body.NurbsC[NurbsCount].cp[7].y = body.CirA[CirCount].cp[0].y - radius;
	body.NurbsC[NurbsCount].cp[8].x = body.CirA[CirCount].cp[0].x + radius;
	body.NurbsC[NurbsCount].cp[8].y = body.CirA[CirCount].cp[0].y;

	for(i=0; i<9; i++){
		body.NurbsC[NurbsCount].cp[i].z = body.CirA[CirCount].zt;	// Z̑傫͈
	}
		
	body.NurbsC[NurbsCount].V[0] = 0.;		// p[^̒l
	body.NurbsC[NurbsCount].V[1] = 1.;

	InitDisplayStat(&body.NurbsC[NurbsCount].Dstat);
	
	return KOD_TRUE;

	// [mۂɎsꍇ͍܂ŊmۂJKOD_ERRԂ
EXIT:
		SetMessage("PARAMETER SECTION KOD_ERROR:fail to allocate memory");
	if(KOD_ERRflag == 3){
		free(body.NurbsC[NurbsCount].cp);
		KOD_ERRflag--;
	}
	if(KOD_ERRflag == 2){
		free(body.NurbsC[NurbsCount].W);
		KOD_ERRflag--;
	}
	if(KOD_ERRflag == 1){
		free(body.NurbsC[NurbsCount].T);
	}
	return KOD_ERR;
}

// Type124(ϊs)pNURBSȐWϊ
int IGES_PARSER::TransformNurbsC(int NurbsCount,int TMp,BODY body)	
{
	int i;

	for(i=0;i<body.NurbsC[NurbsCount].K;i++){
		body.NurbsC[NurbsCount].cp[i] = MulFrameCoord(body.TMat[TMp].R,body.TMat[TMp].T,body.NurbsC[NurbsCount].cp[i]);	
	}
	
	return KOD_TRUE;
}
